UsePNGImageDecoder()
InitSprite()
InitKeyboard()
InitSound()

OpenScreen(800,600,32,"test")


Structure Bullet
  x.i
  y.i
EndStructure
Global NewList Bullet.Bullet()
Procedure AddBullet(x,y)
  AddElement(Bullet())
  Bullet()\x = x
  Bullet()\y = y
EndProcedure

Structure Ship
  x.i
  y.i
EndStructure
Global NewList Ship.Ship()
Procedure AddShip(x,y)
  AddElement(Ship())
  Ship()\x = x
  Ship()\y = y
EndProcedure

LoadSprite(1,"ship1.png")
LoadSprite(2,"ship2.png")

LoadSprite(5,"bullet1.png")

LoadSound(1,"Lazer.wav")
LoadSound(2,"Explosion.wav")

p1x=50
p1y=280

Repeat
  FlipBuffers()
  ClearScreen(0)
  ExamineKeyboard()
  
  If KeyboardPushed(#PB_Key_W):p1y-4:EndIf
  If KeyboardPushed(#PB_Key_S):p1y+4:EndIf
  If KeyboardPushed(#PB_Key_A):p1x-4:EndIf
  If KeyboardPushed(#PB_Key_D):p1x+4:EndIf
  
  If KeyboardReleased(#PB_Key_Space)
    AddBullet(p1x+60,p1y+20)
    PlaySound(1)
  EndIf
  
  DisplaySprite(1,p1x,p1y); eigenes schiff zeichnen
  
  ForEach Ship(); feindliche schiffe zeichnen + shiffs kollision
    Ship()\x-3
    DisplayTransparentSprite(2,Ship()\x,Ship()\y)
    If SpriteCollision(2,Ship()\x,Ship()\y, 1,p1x,p1y)
      MessageRequester("game over!","Score: "+Str(Score))
      ClearScreen(0)
      End
    EndIf
    
    If Ship()\x<-60
      DeleteElement(Ship())
    EndIf
  Next
  
  
  ForEach Bullet(); bullets zeichnen + bullet/ship -collision
    Bullet()\x+6
    DisplayTransparentSprite(5,Bullet()\x,Bullet()\y)
    
    ForEach Ship()
      If SpriteCollision(5,Bullet()\x,Bullet()\y, 2,Ship()\x,Ship()\y)
        PlaySound(2)
        DeleteElement(Ship())
        score+1
      EndIf
    Next
    
    If Bullet()\x>800
      DeleteElement(Bullet())
    EndIf
  Next
  
  
  ; neue schiffe hinzufgen
  If ListSize(Ship())<5 And ElapsedMilliseconds()-time>600
    AddShip(800,Random(560))
    time=ElapsedMilliseconds()
  EndIf
  
  If StartDrawing(ScreenOutput())
    DrawText(5,5,"score: "+Str(score),#Blue)
    
    StopDrawing()
  EndIf
  
Until KeyboardReleased(#PB_Key_Escape)
End